/* PRO-SCAMS "@@(#) display_update.c, Rev: 1.3.0.0" */


/* -----                                                                */
/*                                                                      */
/* UWDIALER Version 1.0                                        12/07/93 */
/*                                                                      */
/* Author: William C. Brown                                             */
/*									*/
/* Display_Msg()							*/
/* 	Add messages to the status area.				*/
/*                                                                      */
/* -------------------------------------------------------------------- */
/* Notes:                                                               */
/*                                                                      */
/*                                                                ----- */

#include <stdio.h>
#include <stropts.h>
#include <termio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xol/OpenLook.h>
#include <Xol/Stub.h>
#include <Xol/ScrollingL.h>
#include "uwdialer.h"

static char Previous_Msg[BUFSIZ];
static char Previous_Time[BUFSIZ];

void Display_Msg(Boolean Init, char *Msg)
{
	extern Widget Stub, ConStub;
	extern GC XORgc;

	(void)Install_Font(SMALL, XORgc);

	if((Boolean)Init == True) {
		(void)memset(Previous_Msg, NULL, BUFSIZ);
		(void)strcpy(Previous_Msg, Msg);
	}
	else {
		XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
			 100, 25, Previous_Msg, strlen(Previous_Msg));
		(void)memset(Previous_Msg, NULL, BUFSIZ);
		(void)strcpy(Previous_Msg, Msg);
	}

	XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
		 100, 25, Msg, strlen(Msg));

	XSync(XtDisplay(Stub), False);

} /* Display_Msg */

void Update_Connect_Clock(XtPointer Ind, XtIntervalId *Id)
{
	static int Hours;
	static int Mins;
	char Time[10];

	extern Widget Stub, ConStub;
	extern GC XORgc;
	extern XtAppContext app_con;
	extern XtIntervalId TimerId; 

	(void)Install_Font(LARGE, XORgc);

	if((int)Ind == INIT) {
		(void)memset(Previous_Time, NULL, BUFSIZ);
		Hours = 0;
		Mins  = 0;
	}

	if((int)Ind == RESET) {
		XtRemoveTimeOut(TimerId);
		XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
			 5, 25, Previous_Time, strlen(Previous_Time));
		(void)Update_Connect_Clock((XtPointer)INIT, NULL);
		return;
	}

	if(((int)Ind == START) || ((int)Ind == RUN)) {
		XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
			 5, 25, Previous_Time, strlen(Previous_Time));
		if((int)Ind == RUN) {
			Mins++;
			if((Mins % 60) == 0) {
				Mins = 0;
				Hours++;
			}
		}
	}

	if((Hours < 10) && (Mins < 10))
		(void)sprintf(Time, "0%d:0%d", Hours, Mins);
	else if ((Hours >= 10) && (Mins < 10))
		(void)sprintf(Time, "%d:0%d", Hours, Mins);
	else if ((Hours < 10) && (Mins >= 10))
		(void)sprintf(Time, "0%d:%d", Hours, Mins);
	else
		(void)sprintf(Time, "%d:%d", Hours, Mins);

	XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
		 5, 25, Time, strlen(Time));

	if(((int)Ind == START) || ((int)Ind == RUN)) {
		TimerId = XtAppAddTimeOut(app_con, 60000,
					  Update_Connect_Clock, RUN);
	}

	(void)strcpy(Previous_Time, Time);
	XSync(XtDisplay(Stub), False);

} /* Update_Connect_Clock */

void Call_Repaint_Display(Widget W, XEvent *xevent, Region region)
{
	static char *Logger_Msg = "- LOG ON -";
	char Xfer_Msg[128];
	extern Widget Stub, ConStub;
	extern XGCValues gcv;
	extern GC ORgc, XORgc;
	extern Pixel RedPixel, GreenPixel;
	extern int LOGGER;
	extern int Xfer_Direction;
	extern Boolean Xfer_InProgress;

	gcv.foreground = GreenPixel;
	XChangeGC(XtDisplay(Stub), ORgc, GCForeground, &gcv);

	(void)Install_Font(LARGE, ORgc);
	XDrawString(XtDisplay(Stub), XtWindow(ConStub), ORgc,
		 5, 25, Previous_Time, strlen(Previous_Time));

	(void)Install_Font(SMALL, ORgc);
	XDrawString(XtDisplay(Stub), XtWindow(ConStub), ORgc,
		 100, 25, Previous_Msg, strlen(Previous_Msg));

	if(LOGGER == ON) {
		gcv.foreground = RedPixel;
		XChangeGC(XtDisplay(Stub), ORgc, GCForeground, &gcv);
		(void)Install_Font(TINY, ORgc);

		XDrawString(XtDisplay(Stub), XtWindow(ConStub), ORgc,
			 100, 35, Logger_Msg, strlen(Logger_Msg));
	}

	if(Xfer_InProgress == True) {
		if(Xfer_Direction == UPLOAD) {
			(void)memset(Xfer_Msg, NULL, 128);
			(void)strcpy(Xfer_Msg, "- UPLOAD IN PROGRESS -");
		}
		else if(Xfer_Direction == DOWNLOAD) {
			(void)memset(Xfer_Msg, NULL, 128);
			(void)strcpy(Xfer_Msg, "- DOWNLOAD IN PROGRESS -");
		}
	}

	if(Xfer_InProgress == True) {
		gcv.foreground = RedPixel;
		XChangeGC(XtDisplay(Stub), ORgc, GCForeground, &gcv);
		(void)Install_Font(TINY, ORgc);

		XDrawString(XtDisplay(Stub), XtWindow(ConStub), ORgc,
			 150, 35, Xfer_Msg, strlen(Xfer_Msg));
	}

} /* Call_Repaint_Clock */

void Install_Font(int FontSize, GC gc)
{
	extern XGCValues gcv;
	extern XFontStruct *Lft, *Sft, *Tft;
	extern Widget Stub;

	if(FontSize == SMALL) {
		gcv.font = Sft->fid;
		XChangeGC(XtDisplay(Stub), gc, GCFont, &gcv);
	}
	else if(FontSize == LARGE) {
		gcv.font = Lft->fid;
		XChangeGC(XtDisplay(Stub), gc, GCFont, &gcv);
	}
	else {
		gcv.font = Tft->fid;
		XChangeGC(XtDisplay(Stub), gc, GCFont, &gcv);
	}
} /* Install_Font */

void Update_Display_Logger(int Indicator)
{
	extern XGCValues gcv;
	extern Widget Stub, ConStub;
	extern Pixel RedPixel, GreenPixel;
	extern GC ORgc, XORgc;
	static char *Logger_Msg = "- LOG ON -";

	gcv.foreground = RedPixel;
	XChangeGC(XtDisplay(Stub), XORgc, GCForeground, &gcv);

	(void)Install_Font(TINY, XORgc);
	XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
		 100, 35, Logger_Msg, strlen(Logger_Msg));

	gcv.foreground = GreenPixel;
	XChangeGC(XtDisplay(Stub), XORgc, GCForeground, &gcv);

	XSync(XtDisplay(Stub), False);

} /* Update_Display_Logger */
	
void Update_Display_Xfer(int Direction)
{
	extern XGCValues gcv;
	extern Widget Stub, ConStub;
	extern Pixel RedPixel, GreenPixel;
	extern GC ORgc, XORgc;
	char Xfer_Msg[128];

	if(Direction == UPLOAD) {
		(void)strcpy(Xfer_Msg, "- UPLOAD IN PROGRESS -");
	}
	else {
		(void)strcpy(Xfer_Msg, "- DOWNLOAD IN PROGRESS -");
	}

	gcv.foreground = RedPixel;
	XChangeGC(XtDisplay(Stub), XORgc, GCForeground, &gcv);

	(void)Install_Font(TINY, XORgc);
	XDrawString(XtDisplay(Stub), XtWindow(ConStub), XORgc,
		 150, 35, Xfer_Msg, strlen(Xfer_Msg));

	gcv.foreground = GreenPixel;
	XChangeGC(XtDisplay(Stub), XORgc, GCForeground, &gcv);
	XSync(XtDisplay(Stub), False);

} /* Update_Display_Xfer */
